package utils

import (
	"math"
	"strconv"
	"strings"
)

func GetFilledNumber(n int, f int) string {
	i := strconv.Itoa(n)
	li := len(i)
	if li > f {
		return strings.Repeat("#", f)
	}
	if li < f {
		return strings.Repeat("0", f-li) + i
	}
	return i
}

func GetFilledNumberWithTruncate(n int, f int) string {
	i := strconv.Itoa(n)
	li := len(i)
	if li > f {
		return i[(li - 2):]
	}
	if li < f {
		return strings.Repeat("0", f-li) + i
	}
	return i
}

func IntDivWithRound(opn int, divn int) int {
	var t float64
	var fdivn float64
	t = float64(opn)
	fdivn = float64(divn)
	t /= fdivn
	return int(math.Round(t))
}
